import 'package:flutter/material.dart';
import 'StoreRF.dart';
import 'uiux/WidgetStylesRF.dart';
import 'uiux/WidgetsRF.dart';
import 'uiux/StyleRF.dart';

abstract class IConfigRF {
  void configure(Configuration _configuration);
}

abstract class IStoryboardRF {
  StoryboardRF customStoryboard(BuildContext context);
}

abstract class IModelRF {
  void register(Models models);
}

class Configuration {
  AppConfigurationRF app = AppConfigurationRF();
  ModelsConfigurationRF model = ModelsConfigurationRF();
  PageConfigurationRF page = PageConfigurationRF();
}

class AppConfigurationRF {
  String title;
  String subTitle;
  TemplateRF template;
  ThemeRF theme;
  IThemeDataRF themeData;

  IPageOutlineRF pageOutline;
  StyleStoreDefaults widgetStyle;
  dynamic onboard; //IAppOnboardRF
}

class ModelsConfigurationRF {
  IModelRF appModels;
  List<Function> validators;
}

enum ScrollEffectRF { appDefault, elastic }

enum TransitionTypeRF {
  fade,
  rightToLeft,
  leftToRight,
  upToDown,
  downToUp,
  scale,
  rotate,
  size,
  rightToLeftWithFade,
  leftToRightWithFade,
}

class PageConfigurationRF {
  TransitionTypeRF transition;
  ScrollEffectRF scrollEffect;
}

class PageImplementationStoreDefaults {
//  final dynamic everything;//
//  final IDrawerScaffoldRF drawer;//
//  final IAppBarScaffoldRF appBar;//
  final IPageOutlineRF outline;

  const PageImplementationStoreDefaults({/*this.everything, this.appBar, this.drawer,*/ this.outline});
}

class Models {
  static Map<String, Object> models = new Map();
  static Map<String, ModelRF> modelsX = new Map();

  const Models();

  Map<String, Object> Get() {
    return models;
  }

  void add1(Object object) {
    models[object.runtimeType.toString()] = object;
  }

  void add(ModelRF model) {
    modelsX[model.model.runtimeType.toString()] = model;
  }
}

class ModelRF {
  Object model;
  String displayName;
  Icon displayIcon;
  dynamic syncStatusField;
  List<Object> fetchDependencies;
  bool fetchIncludeChild;
  Function fetchDependencyCallback;

  ModelRF({
    this.model,
    this.displayName,
    this.displayIcon,
    this.syncStatusField,
    this.fetchDependencies,
    this.fetchIncludeChild = true,
    this.fetchDependencyCallback,
  });
}
